function carouselSetup(){
    // set size of carousel
    $("#carousel").width($("#carousel").closest(".panel").width());
    $("#carousel").height($("#carousel").closest(".panel").height()-25); 

    var options={
       vertical:false, // page up/down
       horizontal:true, // page left/right
       pagingDiv:"carousel_dots", // div to hold the dots for paging
       pagingCssName:"carousel_paging", //classname for the paging dots
       pagingCssNameSelected: "carousel_paging_selected", //classname for the selected page dots
       wrap:false //Creates a continuous carousel
    }

    var carousel = $("#carousel").carousel(options);
}

var cxpos = 0;
var cypos = 0;
var image_x = 0, image_y = 0;
var zoom = 0.5;
var mouse_x = 0, mouse_y = 0, finger_dist = 0;
var source_image_obj = new Image();
source_image_obj.addEventListener('load', function() {reset_settings();}, false); // Reset (x,y,zoom) when new image loads

function load_url(ccimg) {   
    document.getElementById("theurl").value = ccimg;                            
    source_image_obj.src = document.getElementById("theurl").value;  // load the image
}

function update_canvas() {

    var mainCanvas= document.getElementById("mainCanvas");
    mainCanvas.height = window.innerHeight - 60;
    mainCanvas.width = window.innerWidth - 20; 
    
    if (portr && mainCanvas.height < mainCanvas.width)  {
      mainCanvas.height = window.innerWidth - 20;
      mainCanvas.width = window.innerHeight - 60;         
    }
    if (!portr && mainCanvas.width < mainCanvas.height) {
      mainCanvas.height = window.innerWidth - 20;
      mainCanvas.width = window.innerHeight - 60;      
    }   
    
    var mainCanvasCTX = document.getElementById("mainCanvas").getContext("2d");
    var canvas_w = mainCanvas.width, canvas_h = mainCanvas.height; // make things easier to read below
    
    var canx = (canvas_w / 2 - (image_x / zoom)/2);
    var cany = (canvas_h / 2 - (image_y / zoom)/2); 
    //if (cxpos < 0 - canx) cxpos = 0 - canx;
    //if (cxpos > canx) cxpos = canx;
    canx = canx + cxpos;
    cany = cany + cypos;

    mainCanvasCTX.clearRect(0, 0, canvas_w, canvas_h);

    mainCanvasCTX.drawImage(source_image_obj, canx, cany , image_x / zoom, image_y / zoom);

}

function reset_settings() {
    cxpos = 0;
    cypos = 0;
    image_x = source_image_obj.width;
    image_y = source_image_obj.height;
    zoom = 2;
    update_canvas();  // Draw the image in its new position
}

document.addEventListener('wheel', function(e) {
    if(e.deltaY<0){
     zoom = zoom * 1.5;
    } else {
     zoom = zoom / 1.5;
    }
    if (zoom > 2) zoom = 2;
    if (zoom < 0.75) zoom = 0.75;
    update_canvas();
}, false);

document.addEventListener('mousemove', function(e) {
    if(e.buttons>0) {
     window.getSelection().empty();
     //image_x = image_x + zoom * (mouse_x - e.clientX);
     cxpos = cxpos - zoom * (mouse_x - e.clientX);
     //image_y = image_y + zoom * (mouse_y - e.clientY);
     cypos = cypos - zoom * (mouse_y - e.clientY);     
    }
    mouse_x = e.clientX; mouse_y = e.clientY; // Save for next time
    update_canvas(); // draw the image in its new position
}, false);

function get_distance(e) {
    var diffX = e.touches[0].clientX - e.touches[1].clientX;
    var diffY = e.touches[0].clientY - e.touches[1].clientY;
    return Math.sqrt(diffX * diffX + diffY * diffY); // Pythagorean theorem
}

document.addEventListener('touchstart', function(e) {
    if(e.touches.length > 1) { // if multiple touches (pinch zooming)
     finger_dist = get_distance(e); // Save current finger distance
    } // Else just moving around
    mouse_x = e.touches[0].clientX; // Save finger position
    mouse_y = e.touches[0].clientY; //
}, false);

document.addEventListener('touchmove', function(e) {
    e.preventDefault(); // Stop the window from moving
    if(e.touches.length > 1) { // If pinch-zooming
     var new_finger_dist = get_distance(e); // Get current distance between fingers
     zoom = zoom * Math.abs(finger_dist / new_finger_dist); // Zoom is proportional to change
     if (zoom > 2) zoom = 2;
     if (zoom < 0.75) zoom = 0.75;
     finger_dist = new_finger_dist; // Save current distance for next time
    } else { // Else just moving around
     //image_x = image_x + (zoom * (mouse_x - e.touches[0].clientX)); // Move the image
     cxpos = cxpos - zoom * (mouse_x - e.touches[0].clientX);
     cypos = cypos - zoom * (mouse_y - e.touches[0].clientY);
     //image_y = image_y + (zoom * (mouse_y - e.touches[0].clientY)); //
     mouse_x = e.touches[0].clientX; // Save finger position for next time
     mouse_y = e.touches[0].clientY; //
    }
    update_canvas(); // draw the new position
}, false);

document.addEventListener('touchend', function(e) {
    mouse_x = e.touches[0].clientX; mouse_y = e.touches[0].clientY; // could be down to 1 finger, back to moving image
}, false);
  